routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware'=>'language'],function ()
{
    Route::get('/', 'PhotoController@index')->name('home');

    Route::resource('photo', 'PhotoController')->only('index', 'show');

    Route::resource('comments', 'CommentController')->only('store', 'update', 'destroy');

    Route::resource('user', 'UserController')->only('store', 'show', 'destroy');


    Auth::routes();
});

Route::get('language/{locale}', 'LanguageSwitcherController@switcher')
    ->name('language.switcher')
    ->where('locale', 'en|ru');

app/Comment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Comment extends Model
{
    protected $fillable = ['body','appraisal', 'user_id', 'photo_id'];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }


    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function photo()
    {
        return $this->belongsTo(Photo::class);
    }
}

app/Photo.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Photo extends Model
{
    protected $fillable = ['images','title', 'user_id'];


    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }


    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function comments()
    {
        return $this->hasMany(Comment::class);
    }
}

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function photos()
    {
        return $this->hasMany(Photo::class);
    }


    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function comments()
    {
        return $this->hasMany(Comment::class);
    }
}

app/Http/Controllers/CommentController.php
<?php

namespace App\Http\Controllers;

use App\Comment;
use App\Http\Requests\CommentRequest;
use App\Photo;
use Illuminate\Http\Request;

class CommentController extends Controller
{
    /**
     * Store a newly created resource in storage.
     *
     * @param CommentRequest $request
     * @return \Illuminate\Http\Response
     */
    public function store(CommentRequest $request)
    {
        $comment = new Comment();
        $comment->body = $request->input('body');
        $comment->photo_id = $request->input('photo_id');
        $comment->user_id = $request->user()->id;
        $comment->save();

        return redirect()->route('photo', compact('comment'));
    }


    /**
     * Update the specified resource in storage.
     *
     * @param CommentRequest $request
     * @param int $comment_id
     * @param Photo $photo
     * @return \Illuminate\Http\Response
     */
    public function update(CommentRequest $request, int $comment_id,  Photo $photo)
    {
        $comment = Comment::findOrFail($comment_id);
        $comment->update($request->all());

        return view('photo.show', ['photo' => $photo]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id, Photo $photo)
    {
        $comment = Comment::findOrFail($id);
        $comment->delete();

        return view('photo.show', ['photo' => $photo]);
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/LanguageSwitcherController.php
<?php
namespace App\Http\Controllers;


use Illuminate\Http\Request;
class LanguageSwitcherController extends Controller
{
    /**
     * @param Request $request
     * @param string $locale
     * @return \Illuminate\Http\RedirectResponse
     */
    public function switcher(Request $request, string $locale)
    {
        $request->session()->put('locale', $locale);
        return back();
    }
}

app/Http/Controllers/PhotoController.php
<?php

namespace App\Http\Controllers;

use App\Photo;
use App\User;
use Illuminate\Http\Request;

class PhotoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $user = User::all();
        $photos = Photo::all();
        return view('photo.index', compact('photos', 'user'));
    }


    /**
     * Display the specified resource.
     *
     * @param  \App\Photo  $photo
     * @return \Illuminate\Http\Response
     */
    public function show(Photo $photo)
    {
        return view('photo.show', ['photo' => $photo]);
    }

}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PhotoRequest;
use App\Photo;
use App\User;
use Illuminate\Http\Request;

class UserController extends Controller
{

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(PhotoRequest $request)
    {
        $photo = new Photo();
        $file = $request->file('images');
        if (!is_null($file)) {
            $path = $file->store('images', 'public');
            $photo['images'] = $path;
        }
        $photo->user_id = $request->user()->id;
        $photo->save();

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $user = User::findOrFail($id);
        return view('profile.show', compact('user'));
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $user = Photo::findOrFail($id);
        $user->delete();

        return view('profile.show', compact('user'));
    }
}

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ ('Photo Gallery') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ __('Photo Gallery') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">
                        <select class="custom-select" onchange="location = this.value;">
                            <option @if (session('locale') == 'en') selected @endif value="{{route('language.switcher', 'en')}}">
                                EN
                            </option>
                            <option @if (session('locale') == 'ru') selected @endif value="{{route('language.switcher', 'ru')}}">
                                RU
                            </option>
                        </select>
                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="container">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/photo/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        @foreach($photos as $photo)
            <div class="card ml-5 mt-5" style="width: 18rem;">
                <img src="{{asset( '/storage/'. $photo->images)}}" class="card-img-top" alt="...">
                <div class="card-body">
                    <h5 class="card-title">{{$photo->title}}</h5>
                    <hr/>
                    <a href="{{route('user.show', ['user' => $photo->user->id])}}"><h4>{{$photo->user->name}}</h4></a>
                    <a href="{{route('photo.show', ['photo' => $photo])}}" class="btn btn-primary">@lang('Show')</a>
                </div>
            </div>
        @endforeach

    </div>

@endsection

resources/views/photo/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="row mt-4 mb-4">
        <a class="btn btn-primary" href="{{route('photo.index')}}" role="button">@lang('Back')</a>
    </div>
    <div>
        <img src="{{asset( '/storage/'. $photo->images)}}" class="img-fluid img-thumbnail" alt="Адаптивные изображения">
        <h5>@lang('Average score:')</h5>
    </div>

    @if(Auth::check())
    <div class="mt-5">
        <h3>@lang('Add comment')</h3>
        <form action="{{route('comments.store')}}" method="post">
            @csrf
            <div class="form-group row">
                <label for="text" class="col-sm-2 col-form-label">@lang('Text')</label>
                <div class="col-sm-10">
                    <textarea class="form-control" id="text" name="body" rows="3"></textarea>
                </div>
                <label for="text" class="col-sm-2 col-form-label mt-3">@lang('Score')</label>
                <div class="col-sm-10">
                    <select name="appraisal" class="form-control-sm mt-4">
                        <option value="1">1</option>
                        <option value="2">2</option>
                        <option value="3">3</option>
                        <option value="4">4</option>
                        <option value="5">5</option>
                    </select>
                </div>
                <button type="submit" class="btn btn-primary">@lang('Add')</button>
            </div>
        </form>
    </div>
    @endif
<div class="mt-5">
    <h3>@lang('Comments')</h3>
    @foreach($photo->comments as $comment)
        <h4>@lang('Name:') {{$comment->user->name}}, @lang('score') {{$comment->appraisal}}</h4>
        <p>{{$comment->body}}</p>
        <hr>
    @endforeach
</div>
@endsection